//=============================================================================
// SniperBeam.
//=============================================================================
class SniperBeam extends Effects;

#exec obj load file=..\TexTures\FbombTex.utx package=FbombTex

#exec MESH IMPORT MESH=FBBeam ANIVFILE=MODELS\FBBeam_a.3d DATAFILE=MODELS\FBBeam_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=FBBeam X=0 Y=-400 Z=0 YAW=-64

#exec MESH SEQUENCE MESH=FBBeam SEQ=All STARTFRAME=0 NUMFRAMES=21
//#exec MESH SEQUENCE MESH=FBBeam SEQ=??? STARTFRAME=0 NUMFRAMES=21

#exec MESHMAP NEW MESHMAP=FBBeam MESH=FBBeam
#exec MESHMAP SCALE MESHMAP=FBBeam X=0.09 Y=0.21 Z=0.18 YAW=128

#exec MESHMAP SETTEXTURE MESHMAP=FBBeam NUM=0 TEXTURE=FbombTex.skins.C3
#exec MESHMAP SETTEXTURE MESHMAP=FBBeam NUM=1 TEXTURE=FbombTex.skins.FBEnergy

#exec TEXTURE IMPORT NAME=jenergy2 FILE=Textures\jenergy2.bmp GROUP="Skins"



var vector MoveAmount;
var int NumPuffs;

replication
{
     // Things the server should send to the client.
     unreliable if( Role==ROLE_Authority )
          MoveAmount, NumPuffs;
}

simulated function Tick( float DeltaTime )
{
     if ( Level.NetMode  != NM_DedicatedServer )
     {
          ScaleGlow = (Lifespan/Default.Lifespan)*1.0;
          AmbientGlow = ScaleGlow * 210;
     }
}


simulated function PostBeginPlay()
{
     if ( Level.NetMode != NM_DedicatedServer )
          SetTimer(0.0005, false);
}


simulated function Timer ()
{
     local SniperBeam R;

     if ( NumPuffs > 0 )
     {
          R=Spawn(Class'SniperBeam',,,Location + MoveAmount);

          R.NumPuffs=NumPuffs - 1;
          R.MoveAmount=MoveAmount;
     }
}

defaultproperties
{
     Physics=PHYS_Rotating
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=1.500000
     LODBias=4.000000
     Rotation=(Roll=20000)
     DrawType=DT_Mesh
     Style=STY_Translucent
     Mesh=LodMesh'FB3.FBBeam'
     DrawScale=0.800000
     bUnlit=True
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=1
     LightHue=14
     LightRadius=5
     bFixedRotationDir=True
     RotationRate=(Roll=400000)
     DesiredRotation=(Roll=600000)
}
