class bonebar2 extends TournamentWeapon;

#exec AUDIO IMPORT FILE="Sounds\Barret.Wav" NAME=Barret GROUP="Weapons"

#exec MESH IMPORT MESH=Sniper ANIVFILE=MODELS\Sniper_a.3d DATAFILE=MODELS\Sniper_d.3d X=0 Y=0 Z=0 //Unmirror=1
#exec MESH ORIGIN MESH=Sniper X=0 Y=300 Z=-80 YAW=-195 //PITCH=6

#exec MESH SEQUENCE MESH=Sniper SEQ=All STARTFRAME=0 NUMFRAMES=9
#exec MESH SEQUENCE MESH=Sniper SEQ=Fire STARTFRAME=0 NUMFRAMES=21
#exec MESH SEQUENCE MESH=Sniper SEQ=Select STARTFRAME=0 NUMFRAMES=9 RATE=5 GROUP=Select
#exec MESHMAP NEW   MESHMAP=Sniper MESH=Sniper
#exec MESHMAP SCALE MESHMAP=Sniper X=0.05 Y=0.05 Z=0.1

#exec TEXTURE IMPORT NAME=JSniper_01 FILE=Textures\FBTex.PCX GROUP=Skins LODSET=2	//Material #1
#exec TEXTURE IMPORT NAME=JSniper_02 FILE=Textures\FBTex.PCX GROUP=Skins LODSET=2	//2

#exec MESHMAP SETTEXTURE MESHMAP=Sniper NUM=1 TEXTURE=JSniper_01
#exec MESHMAP SETTEXTURE MESHMAP=Sniper NUM=2 TEXTURE=unrealshare.effect3.fireeffect3a
//#exec MESHMAP SETTEXTURE MESHMAP=Sniper NUM=3 TEXTURE=unrealshare.belt_FX.BlueShield
//3rd person

#exec MESH IMPORT MESH=Sniper3rd ANIVFILE=MODELS\Sniper3rd_a.3d DATAFILE=MODELS\Sniper3rd_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=Sniper3rd X=0 Y=300 Z=-80 YAW=-195 //PITCH=6

#exec MESH SEQUENCE MESH=Sniper3rd SEQ=All                      STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Sniper3rd SEQ=still                    STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=Sniper3rd MESH=Sniper3rd
#exec MESHMAP SCALE MESHMAP=Sniper3rd X=0.05 Y=0.05 Z=0.1

#exec TEXTURE IMPORT NAME=JSniper3rd_01 FILE=Textures\FBTex.PCX GROUP=Skins LODSET=2	//Material #1

#exec MESHMAP SETTEXTURE MESHMAP=Sniper3rd NUM=1 TEXTURE=JSniper3rd_01
#exec MESHMAP SETTEXTURE MESHMAP=Sniper3rd NUM=2 TEXTURE=unrealshare.effect3.fireeffect3a
//#exec MESHMAP SETTEXTURE MESHMAP=Sniper3rd NUM=3 TEXTURE=unrealshare.belt_FX.BlueShield

//pickup

#exec MESH IMPORT MESH=Sniperpickup ANIVFILE=MODELS\Sniperpickup_a.3d DATAFILE=MODELS\Sniperpickup_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=Sniperpickup X=0 Y=300 Z=-80 YAW=-195 //PITCH=6

#exec MESH SEQUENCE MESH=Sniperpickup SEQ=All                      STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Sniperpickup SEQ=Still                    STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=Sniperpickup MESH=Sniperpickup
#exec MESHMAP SCALE MESHMAP=Sniperpickup X=0.05 Y=0.05 Z=0.1

#exec TEXTURE IMPORT NAME=JSniperpickup_01 FILE=Textures\FBTex.PCX GROUP=Skins LODSET=2	//Material #1

#exec MESHMAP SETTEXTURE MESHMAP=Sniperpickup NUM=1 TEXTURE=JSniperpickup_01
#exec MESHMAP SETTEXTURE MESHMAP=Sniperpickup NUM=2 TEXTURE=unrealshare.effect3.fireeffect3a
#exec TEXTURE IMPORT NAME=scp FILE=TEXTURES\scp.PCX GROUP="Icons" MIPS=OFF FLAGS=2 LODSET=2



var int NumFire;
var vector OwnerLocation;
var float StillTime, StillStart;
var int Count;
var() config bool bNeverStay;

simulated function PostRender( canvas Canvas )
{
	local PlayerPawn P;
	local float Scale;

	Super.PostRender(Canvas);
	P = PlayerPawn(Owner);
	if ( (P != None) && (P.DesiredFOV != P.DefaultFOV) )
	{
		bOwnsCrossHair = true;
		Scale = Canvas.ClipX/640;
		Canvas.SetPos(0.5 * Canvas.ClipX - 128 * Scale, 0.5 * Canvas.ClipY - 128 * Scale );
		Canvas.Style = ERenderStyle.STY_Translucent;
		Canvas.DrawIcon(Texture'scp', Scale);
		Canvas.SetPos(0.5 * Canvas.ClipX + 64 * Scale, 0.5 * Canvas.ClipY + 96 * Scale);
		Canvas.DrawColor = 15 * ChallengeHUD(PlayerPawn(Owner).myhud).CrosshairColor;
		Scale = P.DefaultFOV/P.DesiredFOV;
		Canvas.DrawText("X"$int(Scale)$"."$int(10 * Scale - 10 * int(Scale)));
	}
	else
		bOwnsCrossHair = false;
}


function float RateSelf( out int bUseAltMode )
{
	local float dist;

	if ( AmmoType.AmmoAmount <=0 )
		return -2;

	bUseAltMode = 0;
	if ( (Bot(Owner) != None) && Bot(Owner).bSniping )
		return AIRating + 1.15;
	if (  Pawn(Owner).Enemy != None )
	{
		dist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
		if ( dist > 1200 )
		{
                         return (AIRating + 0.25);
		}
	}
	return AIRating;
}



simulated function PlayFiring()
{
	local int r;
	local PlayerPawn PlayerOwner;
        local sniperbeam S;


	PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
	PlayAnim('Fire', 0.75);
	if (PlayerPawn(Owner) != None)
		bMuzzleFlash++;



}

simulated function bool ClientAltFire( float Value )
{
	GotoState('Zooming');
	return true;
}

function AltFire( float Value )
{
	ClientAltFire(Value);
}

///////////////////////////////////////////////////////
state NormalFire
{

	function EndState()
	{


		Super.EndState();
		OldFlashCount = FlashCount;

	}

Begin:

	PlayFiring();
        bMuzzleflash++;
	Tracefire(0.0);
	ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
	FlashCount++;
        AimError = Default.AimError;
	FinishAnim();
        Finish();
    


}

function Timer()
{
	local actor targ;
	local float bestAim, bestDist;
	local vector FireDir;
	local Pawn P;

      
	bestAim = 0.95;
	P = Pawn(Owner);
	if ( P == None )
	{
		GotoState('');
		return;
	}
	if ( VSize(P.Location - OwnerLocation) < 6 )
		StillTime += FMin(2.0, Level.TimeSeconds - StillStart);

	else
		StillTime = 0;
	StillStart = Level.TimeSeconds;
	OwnerLocation = P.Location;
	FireDir = vector(P.ViewRotation);
	targ = P.PickTarget(bestAim, bestDist, FireDir, Owner.Location);
	if ( Pawn(targ) != None )
	{
		SetTimer(1 + 4 * FRand(), false);
		bPointing = true;
		Pawn(targ).WarnTarget(P, 200, FireDir);
	}
	else
	{
		SetTimer(0.4 + 1.6 * FRand(), false);
		if ( (P.bFire == 0) && (P.bAltFire == 0) )
			bPointing = false;
	}
}

// set which hand is holding weapon
simulated function setHand(float hand) 
{
        local weapon NewWeapon;
        local pawn p;

	Super.SetHand(Hand);
	if (( Hand == 1 ) && (P.IsA('PlayerPawn')))
        NewWeapon.SetHand(PlayerPawn(P).Handedness);

}

function setWeaponStay() {
	 if (bNeverStay)
	      bWeaponStay = false;
	 else
	      super.setWeaponStay();
}


function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local UT_Shellcase s;
	local PlayerPawn PlayerOwner;

if (Other==None)
     {
          HitNormal = -X;
          HitLocation = Owner.Location + X*10000.0;
     }


 PlayerOwner = PlayerPawn(Owner);
     if ( PlayerOwner != None )
          PlayerOwner.ClientInstantFlash( -0.4, vect(450, 190, 650));
     SpawnEffect(HitLocation, Owner.Location + CalcDrawOffset() + (FireOffset.X + 20) * X + FireOffset.Y * Y + FireOffset.Z * Z);


	s = Spawn(class'UT_ShellCase',, '', Owner.Location + CalcDrawOffset() + 30 * X + (2.8 * FireOffset.Y+5.0) * Y - Z * 1);
	if ( s != None ) 
	{
		s.DrawScale = 2.0;
		s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.2+0.2)*Y + (FRand()*0.3+1.0) * Z)*160);              
	}
	if (Other == Level) 
		Spawn(class'hitexplo',,, HitLocation+HitNormal, Rotator(HitNormal));
        
	else if ( (Other != self) && (Other != Owner) && (Other != None) ) 
	{
		if ( Other.bIsPawn )
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
		if ( Other.bIsPawn && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight) 
			&& (instigator.IsA('PlayerPawn') || (instigator.IsA('Bot') && !Bot(Instigator).bNovice)) )
			Other.TakeDamage(100, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
		        SpawnEffect(HitLocation, Owner.Location + CalcDrawOffset() + (FireOffset.X + 20) * X + FireOffset.Y * Y + FireOffset.Z * Z);
			Spawn(class'hitexplo',,, HitLocation+HitNormal, Rotator(HitNormal));
                     } else {
			Other.TakeDamage(45,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);	
		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			SpawnEffect(HitLocation, Owner.Location + CalcDrawOffset() + (FireOffset.X + 20) * X + FireOffset.Y * Y + FireOffset.Z * Z);
	Spawn(class'hitexplo',,, HitLocation+HitNormal, Rotator(HitNormal));
     }
     
     
     
    
}

function SpawnEffect(vector HitLocation, vector SmokeLocation)
{
     local SniperBeam Smoke,shock;
     local Vector DVector;
     local int NumPoints;
     local rotator SmokeRotation;

     DVector = HitLocation - SmokeLocation;
     NumPoints = VSize(DVector)/135.0;
     if ( NumPoints < 1 )
          return;
     SmokeRotation = rotator(DVector);
     SmokeRotation.roll = Rand(65535);

     Smoke = Spawn(class'SniperBeam',,,SmokeLocation,SmokeRotation);
     Smoke.MoveAmount = DVector/NumPoints;
     Smoke.NumPuffs = NumPoints - 1;
}


function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z, AimDir;
	local actor Other;

	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	StartTrace = Owner.Location + pawn(owner).Eyeheight * Z;
	//adjust for current accuracy of weapon and player
	AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, StartTrace, 2*AimError, False, False);	
	X = vector(AdjustedAim);
	EndTrace = StartTrace + 10000 * X;
	AimDir = vector(AdjustedAim);	
	Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
	
	Count++;
	if ( Count == 1 )
	{
		Count = 0;
		if ( VSize(HitLocation - StartTrace) > 250 )
			Spawn(class'racerbnz',,, StartTrace + 96 * AimDir,rotator(EndTrace - StartTrace));
	}
	
	return Spawn(ProjClass,,, StartTrace,AdjustedAim);

}


function Finish()
{
	if ( (Pawn(Owner).bFire!=0) && (FRand() < 0.6) )
		Timer();
	Super.Finish();
}

state Idle
{
	function Fire( float Value )
	{
		if ( AmmoType == None )
		{
			// ammocheck
			GiveAmmo(Pawn(Owner));
		}
		if (AmmoType.UseAmmo(1))
		{
			GotoState('NormalFire');
			bCanClientFire = true;
			bPointing=True;
			if ( Owner.IsA('Bot') )
			{
				// simulate bot using zoom
				if ( Bot(Owner).bSniping && (FRand() < 0.65) )
					AimError = AimError/FClamp(StillTime, 1.0, 8.0);
				else if ( VSize(Owner.Location - OwnerLocation) < 6 )
					AimError = AimError/FClamp(0.5 * StillTime, 1.0, 3.0);
				else
					StillTime = 0;
			}
			Pawn(Owner).PlayRecoil(FiringSpeed);
//			ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
			AimError = Default.AimError;
			ClientFire(Value);
		}
	}



	function BeginState()
	{
		bPointing = false;
		SetTimer(0.4 + 1.6 * FRand(), false);
		Super.BeginState();
	}

	function EndState()
	{
		SetTimer(0.0, false);
		Super.EndState();
	}

Begin:
	bPointing=False;
	if ( AmmoType.AmmoAmount<=0 )
		Pawn(Owner).SwitchToBestWeapon();  //Goto Weapon that has Ammo
	if ( Pawn(Owner).bFire!=0 ) Fire(0.0);
	Disable('AnimEnd');
	PlayIdleAnim();
}

///////////////////////////////////////////////////////////////////////////////////
state Zooming
{
	simulated function Tick(float DeltaTime)
	{
		if ( Pawn(Owner).bAltFire == 0 )
		{
			if ( (PlayerPawn(Owner) != None) && PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).StopZoom();
			SetTimer(0.0,False);
			GoToState('Idle');
		}
	}

	simulated function BeginState()
	{
		if ( Owner.IsA('PlayerPawn') )
		{
			if ( PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).ToggleZoom();
			SetTimer(0.2,True);
		}
		else
		{
			Pawn(Owner).bFire = 1;
			Pawn(Owner).bAltFire = 0;
			Global.Fire(0);
		}
	}
}

///////////////////////////////////////////////////////////
simulated function PlayIdleAnim()
{
	if ( Mesh != PickupViewMesh )
		PlayAnim('Still',1.0, 0.05);
}

defaultproperties
{
     bNeverStay=True
     WeaponDescription="Classification: 50cal FleshBomb Rifle"
     AmmoName=Class'FB3.BarretAmmo'
     PickupAmmoCount=20
     bInstantHit=True
     bAltInstantHit=True
     ProjectileClass=Class'FB3.shBomb'
     shakemag=550.000000
     AIRating=0.540000
     RefireRate=0.250000
     AltRefireRate=0.250000
     FireSound=Sound'FB3.Weapons.Barret'
     SelectSound=Sound'UnrealI.Rifle.RiflePickup'
     DeathMessage="%k nuked the skin right off %o's body."
     NameColor=(R=0)
     bDrawMuzzleFlash=True
     MuzzleScale=1.000000
     FlashY=0.110000
     FlashO=0.010000
     FlashC=0.030000
     FlashLength=0.010000
     FlashS=256
     MFTexture=Texture'Botpack.Rifle.MuzzleFlash2'
     AutoSwitchPriority=5
     InventoryGroup=9
     bRotatingPickup=False
     PickupMessage="You got a Flesh Bomb Rifle."
     ItemName="FleshBomb Rifle"
     RespawnTime=60.000000
     PlayerViewOffset=(X=4.800000,Y=-2.500000,Z=-4.500000)
     PlayerViewMesh=LodMesh'FB3.Sniper'
     PlayerViewScale=0.200000
     BobDamping=0.980000
     PickupViewMesh=LodMesh'FB3.Sniperpickup'
     ThirdPersonMesh=LodMesh'FB3.Sniper3rd'
     ThirdPersonScale=0.680000
     StatusIcon=Texture'Botpack.Icons.UseRifle'
     bMuzzleFlashParticles=True
     MuzzleFlashMesh=LodMesh'Botpack.muzzsr3'
     MuzzleFlashScale=0.100000
     MuzzleFlashTexture=Texture'Botpack.Skins.Muzzy3'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Icon=Texture'Botpack.Icons.UseRifle'
     LODBias=4.000000
     Mesh=LodMesh'FB3.Sniper3rd'
     DrawScale=5.000000
     bNoSmooth=False
     CollisionRadius=32.000000
     CollisionHeight=1.000000
}
